
-------------------------------------------------------------------------------
-- Optimization
-------------------------------------------------------------------------------

-- GLOBALS: IsAltKeyDown, strsplit, tonumber

-------------------------------------------------------------------------------
-- Namespace
-------------------------------------------------------------------------------

local A, B, C, D = unpack(select(2, ...)) -- AddOn, Border, Constants, Database
local M = A:NewModule("Chat Invite")
local Social = LibStub("SixSocial-1.0")

local LINK_TYPE = {battleTag = true, BNplayer = true, player = true}

-------------------------------------------------------------------------------
-- Module
-------------------------------------------------------------------------------

function M:OnEnable()
	if not self:IsHooked("SetItemRef") then
		self:SecureHook("SetItemRef")
	end
end

-------------------------------------------------------------------------------
-- Hooks
-------------------------------------------------------------------------------

function M:SetItemRef(link)
	if not IsAltKeyDown() then return end
	local type, arg1, arg2 = strsplit(":", link)
	if not LINK_TYPE[type] then return end
	local friend = (type == "battleTag" and Social:GetFriendByBattleTag(arg1))
		or (type == "BNplayer" and Social:GetFriendByAccountID(tonumber(arg2)))
		or (type == "player" and Social:WrapUnitInFriend(arg1))

	if friend then
		friend:SendInvite()
	end

	A.CloseEditBox()
end
